Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/JVC.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/JVC.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/JVC.pm	(revision 34921)
@@ -11,7 +11,8 @@
 use strict;
 use vars qw($VERSION);
+use Image::ExifTool qw(:DataAccess :Utils);
 use Image::ExifTool::Exif;
 
-$VERSION = '1.02';
+$VERSION = '1.03';
 
 sub ProcessJVCText($$$);
@@ -63,26 +64,26 @@
 sub ProcessJVCText($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     my $dataPt = $$dirInfo{DataPt};
     my $dirStart = $$dirInfo{DirStart} || 0;
     my $dataLen = $$dirInfo{DataLen};
     my $dirLen = $$dirInfo{DirLen} || $dataLen - $dirStart;
-    my $verbose = $exifTool->Options('Verbose');
+    my $verbose = $et->Options('Verbose');
 
     my $data = substr($$dataPt, $dirStart, $dirLen);
     # validate text maker notes
     unless ($data =~ /^VER:/) {
-        $exifTool->Warn('Bad JVC text maker notes');
+        $et->Warn('Bad JVC text maker notes');
         return 0;
     }
     while ($data =~ m/([A-Z]+):(.{3,4})/sg) {
         my ($tag, $val) = ($1, $2);
-        my $tagInfo = $exifTool->GetTagInfo($tagTablePtr, $tag);
-        $exifTool->VerboseInfo($tag, $tagInfo,
+        my $tagInfo = $et->GetTagInfo($tagTablePtr, $tag);
+        $et->VerboseInfo($tag, $tagInfo,
             Table  => $tagTablePtr,
             Value  => $val,
         ) if $verbose;
         unless ($tagInfo) {
-            next unless $exifTool->{OPTIONS}->{Unknown};
+            next unless $$et{OPTIONS}{Unknown};
             $tagInfo = {
                 Name => "JVC_Text_$tag",
@@ -91,7 +92,7 @@
             };
             # add tag information to table
-            Image::ExifTool::AddTagToTable($tagTablePtr, $tag, $tagInfo);
+            AddTagToTable($tagTablePtr, $tag, $tagInfo);
         }
-        $exifTool->FoundTag($tagInfo, $val);
+        $et->FoundTag($tagInfo, $val);
     }
     return 1;
@@ -117,5 +118,5 @@
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Jpeg2000.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Jpeg2000.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Jpeg2000.pm	(revision 34921)
@@ -17,5 +17,5 @@
 use Image::ExifTool qw(:DataAccess :Utils);
 
-$VERSION = '1.16';
+$VERSION = '1.27';
 
 sub ProcessJpeg2000Box($$$);
@@ -58,4 +58,6 @@
 my %uuid = (
     'UUID-EXIF'   => 'JpgTiffExif->JP2',
+    'UUID-EXIF2'  => '',    # (flags a warning when writing)
+    'UUID-EXIF_bad' => '0', # (flags a warning when reading and writing)
     'UUID-IPTC'   => "\x33\xc7\xa4\xd2\xb8\x1d\x47\x23\xa0\xba\xf1\xa3\xe0\x97\xad\x38",
     'UUID-XMP'    => "\xbe\x7a\xcf\xcb\x97\xa9\x42\xe8\x9c\x71\x99\x94\x91\xe3\xaf\xac",
@@ -64,9 +66,45 @@
 );
 
+# JPEG2000 codestream markers (ref ISO/IEC FCD15444-1/2)
+my %j2cMarker = (
+    0x4f => 'SOC', # start of codestream
+    0x51 => 'SIZ', # image and tile size
+    0x52 => 'COD', # coding style default
+    0x53 => 'COC', # coding style component
+    0x55 => 'TLM', # tile-part lengths
+    0x57 => 'PLM', # packet length, main header
+    0x58 => 'PLT', # packet length, tile-part header
+    0x5c => 'QCD', # quantization default
+    0x5d => 'QCC', # quantization component
+    0x5e => 'RGN', # region of interest
+    0x5f => 'POD', # progression order default
+    0x60 => 'PPM', # packed packet headers, main
+    0x61 => 'PPT', # packed packet headers, tile-part
+    0x63 => 'CRG', # component registration
+    0x64 => 'CME', # comment and extension
+    0x90 => 'SOT', # start of tile-part
+    0x91 => 'SOP', # start of packet
+    0x92 => 'EPH', # end of packet header
+    0x93 => 'SOD', # start of data
+    # extensions (ref ISO/IEC FCD15444-2)
+    0x70 => 'DCO', # variable DC offset
+    0x71 => 'VMS', # visual masking
+    0x72 => 'DFS', # downsampling factor style
+    0x73 => 'ADS', # arbitrary decomposition style
+  # 0x72 => 'ATK', # arbitrary transformation kernels ?
+    0x78 => 'CBD', # component bit depth
+    0x74 => 'MCT', # multiple component transformation definition
+    0x75 => 'MCC', # multiple component collection
+    0x77 => 'MIC', # multiple component intermediate collection
+    0x76 => 'NLT', # non-linearity point transformation
+);
+
 # JPEG 2000 "box" (ie. atom) names
+# Note: only tags with a defined "Format" are extracted
 %Image::ExifTool::Jpeg2000::Main = (
     GROUPS => { 2 => 'Image' },
     PROCESS_PROC => \&ProcessJpeg2000Box,
     WRITE_PROC => \&ProcessJpeg2000Box,
+    PREFERRED => 1, # always add these tags when writing
     NOTES => q{
         The tags below are extracted from JPEG 2000 images, however ExifTool
@@ -93,29 +131,10 @@
         },
         bpcc => 'BitsPerComponent',
-        colr => [
-            {
-                Name => 'ICC_Profile',
-                Condition => '$$valPt =~ /^(\x02|\x03)/',
-                SubDirectory => {
-                    TagTable => 'Image::ExifTool::ICC_Profile::Main',
-                    Start => '$valuePtr + 3',
-                },
-            },
-            {
-                Name => 'Colorspace',
-                Condition => '$$valPt =~ /^\x01/',
-                Format => 'binary',
-                ValueConv => 'unpack("x3N", $val)',
-                PrintConv => {
-                    16 => 'sRGB',
-                    17 => 'Grayscale',
-                    18 => 'sYCC',
-                },
-            },
-            {
-                Name => 'ColorSpecification',
-                Binary => 1,
-            },
-        ],
+        colr => {
+            Name => 'ColorSpecification',
+            SubDirectory => {
+                TagTable => 'Image::ExifTool::Jpeg2000::ColorSpec',
+            },
+        },
         pclr => 'Palette',
         cdef => 'ComponentDefinition',
@@ -168,5 +187,9 @@
     copt => 'CompositionOptions',
     inst => 'InstructionSet',
-    asoc => 'Association',
+    asoc => {
+        Name => 'Association',
+        SubDirectory => { },
+    },
+        # (Association box may contain any other sub-box)
     nlst => 'NumberList',
     bfil => 'BinaryFilter',
@@ -180,18 +203,26 @@
     jp2i => {
         Name => 'IntellectualProperty',
-        SubDirectory => {
-            TagTable => 'Image::ExifTool::XMP::Main',
-        },
+        SubDirectory => { TagTable => 'Image::ExifTool::XMP::Main' },
     },
    'xml '=> {
         Name => 'XML',
-        SubDirectory => {
-            TagTable => 'Image::ExifTool::XMP::Main',
-        },
+        Writable => 'undef',
+        Flags => [ 'Binary', 'Protected', 'BlockExtract' ],
+        List => 1,
+        Notes => q{
+            by default, the XML data in this tag is parsed using the ExifTool XMP module
+            to to allow individual tags to be accessed when reading, but it may also be
+            extracted as a block via the "XML" tag, which is also how this tag is
+            written and copied.  This is a List-type tag because multiple XML blocks may
+            exist
+        },
+        # (note: extracting as a block was broken in 11.04, and finally fixed in 12.14)
+        SubDirectory => { TagTable => 'Image::ExifTool::XMP::XML' },
     },
     uuid => [
         {
             Name => 'UUID-EXIF',
-            Condition => '$$valPt=~/^JpgTiffExif->JP2/',
+            # (this is the EXIF that we create)
+            Condition => '$$valPt=~/^JpgTiffExif->JP2(?!Exif\0\0)/',
             SubDirectory => {
                 TagTable => 'Image::ExifTool::Exif::Main',
@@ -203,6 +234,40 @@
         },
         {
+            Name => 'UUID-EXIF2',
+            # written by Photoshop 7.01+Adobe JPEG2000-plugin v1.5
+            Condition => '$$valPt=~/^\x05\x37\xcd\xab\x9d\x0c\x44\x31\xa7\x2a\xfa\x56\x1f\x2a\x11\x3e/',
+            SubDirectory => {
+                TagTable => 'Image::ExifTool::Exif::Main',
+                ProcessProc => \&Image::ExifTool::ProcessTIFF,
+                WriteProc => \&Image::ExifTool::WriteTIFF,
+                DirName => 'EXIF',
+                Start => '$valuePtr + 16',
+            },
+        },
+        {
+            Name => 'UUID-EXIF_bad',
+            # written by Digikam
+            Condition => '$$valPt=~/^JpgTiffExif->JP2/',
+            SubDirectory => {
+                TagTable => 'Image::ExifTool::Exif::Main',
+                ProcessProc => \&Image::ExifTool::ProcessTIFF,
+                WriteProc => \&Image::ExifTool::WriteTIFF,
+                DirName => 'EXIF',
+                Start => '$valuePtr + 22',
+            },
+        },
+        {
             Name => 'UUID-IPTC',
+            # (this is the IPTC that we create)
             Condition => '$$valPt=~/^\x33\xc7\xa4\xd2\xb8\x1d\x47\x23\xa0\xba\xf1\xa3\xe0\x97\xad\x38/',
+            SubDirectory => {
+                TagTable => 'Image::ExifTool::IPTC::Main',
+                Start => '$valuePtr + 16',
+            },
+        },
+        {
+            Name => 'UUID-IPTC2',
+            # written by Photoshop 7.01+Adobe JPEG2000-plugin v1.5
+            Condition => '$$valPt=~/^\x09\xa1\x4e\x97\xc0\xb4\x42\xe0\xbe\xbf\x36\xdf\x6f\x0c\xe3\x6f/',
             SubDirectory => {
                 TagTable => 'Image::ExifTool::IPTC::Main',
@@ -230,6 +295,20 @@
         },
         {
+            Name => 'UUID-Photoshop',
+            # written by Photoshop 7.01+Adobe JPEG2000-plugin v1.5
+            Condition => '$$valPt=~/^\x2c\x4c\x01\x00\x85\x04\x40\xb9\xa0\x3e\x56\x21\x48\xd6\xdf\xeb/',
+            SubDirectory => {
+                TagTable => 'Image::ExifTool::Photoshop::Main',
+                Start => '$valuePtr + 16',
+            },
+        },
+        {
             Name => 'UUID-Unknown',
         },
+        # also written by Adobe JPEG2000 plugin v1.5:
+        # 3a 0d 02 18 0a e9 41 15 b3 76 4b ca 41 ce 0e 71 - 1 byte (01)
+        # 47 c9 2c cc d1 a1 45 81 b9 04 38 bb 54 67 71 3b - 1 byte (01)
+        # bc 45 a7 74 dd 50 4e c6 a9 f6 f3 a1 37 f4 7e 90 - 4 bytes (00 00 00 32)
+        # d7 c8 c5 ef 95 1f 43 b2 87 57 04 25 00 f5 38 e8 - 4 bytes (00 00 00 32)
     ],
     uinf => {
@@ -308,5 +387,5 @@
         Format => 'undef[$size-8]',
         # ignore any entry with a null, and return others as a list
-        ValueConv => 'my @a=($val=~/.{4}/sg); @a=grep(!/\0/,@a); \@a', 
+        ValueConv => 'my @a=($val=~/.{4}/sg); @a=grep(!/\0/,@a); \@a',
     },
 );
@@ -360,15 +439,109 @@
 );
 
+%Image::ExifTool::Jpeg2000::ColorSpec = (
+    PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
+    GROUPS => { 2 => 'Image' },
+    FORMAT => 'int8s',
+    0 => {
+        Name => 'ColorSpecMethod',
+        RawConv => '$$self{ColorSpecMethod} = $val',
+        PrintConv => {
+            1 => 'Enumerated',
+            2 => 'Restricted ICC',
+            3 => 'Any ICC',
+            4 => 'Vendor Color',
+        },
+    },
+    1 => 'ColorSpecPrecedence',
+    2 => {
+        Name => 'ColorSpecApproximation',
+        PrintConv => {
+            0 => 'Not Specified',
+            1 => 'Accurate',
+            2 => 'Exceptional Quality',
+            3 => 'Reasonable Quality',
+            4 => 'Poor Quality',
+        },
+    },
+    3 => [
+        {
+            Name => 'ICC_Profile',
+            Condition => q{
+                $$self{ColorSpecMethod} == 2 or
+                $$self{ColorSpecMethod} == 3
+            },
+            Format => 'undef[$size-3]',
+            SubDirectory => {
+                TagTable => 'Image::ExifTool::ICC_Profile::Main',
+            },
+        },
+        {
+            Name => 'ColorSpace',
+            Condition => '$$self{ColorSpecMethod} == 1',
+            Format => 'int32u',
+            PrintConv => { # ref 15444-2 2002-05-15
+                0 => 'Bi-level',
+                1 => 'YCbCr(1)',
+                3 => 'YCbCr(2)',
+                4 => 'YCbCr(3)',
+                9 => 'PhotoYCC',
+                11 => 'CMY',
+                12 => 'CMYK',
+                13 => 'YCCK',
+                14 => 'CIELab',
+                15 => 'Bi-level(2)', # (incorrectly listed as 18 in 15444-2 2000-12-07)
+                16 => 'sRGB',
+                17 => 'Grayscale',
+                18 => 'sYCC',
+                19 => 'CIEJab',
+                20 => 'e-sRGB',
+                21 => 'ROMM-RGB',
+                # incorrect in 15444-2 2000-12-07
+                #22 => 'sRGB based YCbCr',
+                #23 => 'YPbPr(1125/60)',
+                #24 => 'YPbPr(1250/50)',
+                22 => 'YPbPr(1125/60)',
+                23 => 'YPbPr(1250/50)',
+                24 => 'e-sYCC',
+            },
+        },
+        {
+            Name => 'ColorSpecData',
+            Format => 'undef[$size-3]',
+            Binary => 1,
+        },
+    ],
+);
+
 #------------------------------------------------------------------------------
 # Create new JPEG 2000 boxes when writing
-# (Currently only supports adding certain UUID boxes)
+# (Currently only supports adding top-level Writable JPEG2000 tags and certain UUID boxes)
 # Inputs: 0) ExifTool object ref, 1) Output file or scalar ref
 # Returns: 1 on success
 sub CreateNewBoxes($$)
 {
-    my ($exifTool, $outfile) = @_;
-    my $addDirs = $$exifTool{AddJp2Dirs};
-    delete $$exifTool{AddJp2Dirs};
-    my $dirName;
+    my ($et, $outfile) = @_;
+    my $addTags = $$et{AddJp2Tags};
+    my $addDirs = $$et{AddJp2Dirs};
+    delete $$et{AddJp2Tags};
+    delete $$et{AddJp2Dirs};
+    my ($tag, $dirName);
+    # add JPEG2000 tags
+    foreach $tag (sort keys %$addTags) {
+        my $tagInfo = $$addTags{$tag};
+        my $nvHash = $et->GetNewValueHash($tagInfo);
+        # (native JPEG2000 information is always preferred, so don't check IsCreating)
+        next unless $$tagInfo{List} or $et->IsOverwriting($nvHash) > 0;
+        next if $$nvHash{EditOnly};
+        my @vals = $et->GetNewValue($nvHash);
+        my $val;
+        foreach $val (@vals) {
+            my $boxhdr = pack('N', length($val) + 8) . $$tagInfo{TagID};
+            Write($outfile, $boxhdr, $val) or return 0;
+            ++$$et{CHANGED};
+            $et->VerboseValue("+ Jpeg2000:$$tagInfo{Name}", $val);
+        }
+    }
+    # add UUID boxes
     foreach $dirName (sort keys %$addDirs) {
         next unless $uuid{$dirName};
@@ -382,5 +555,8 @@
                 Parent => 'JP2',
             );
-            my $newdir = $exifTool->WriteDirectory(\%dirInfo, $tagTable, $$subdir{WriteProc});
+            # remove "UUID-" from start of directory name to allow appropriate
+            # directories to be written as a block
+            $dirInfo{DirName} =~ s/^UUID-//;
+            my $newdir = $et->WriteDirectory(\%dirInfo, $tagTable, $$subdir{WriteProc});
             if (defined $newdir and length $newdir) {
                 my $boxhdr = pack('N', length($newdir) + 24) . 'uuid' . $uuid{$dirName};
@@ -400,5 +576,5 @@
 sub ProcessJpeg2000Box($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     my $dataPt = $$dirInfo{DataPt};
     my $dataLen = $$dirInfo{DataLen};
@@ -406,4 +582,5 @@
     my $dirLen = $$dirInfo{DirLen} || 0;
     my $dirStart = $$dirInfo{DirStart} || 0;
+    my $base = $$dirInfo{Base} || 0;
     my $raf = $$dirInfo{RAF};
     my $outfile = $$dirInfo{OutFile};
@@ -419,5 +596,6 @@
     } else {
         # (must not set verbose flag when writing!)
-        $verbose = $exifTool->{OPTIONS}->{Verbose};
+        $verbose = $$et{OPTIONS}{Verbose};
+        $et->VerboseDir($$dirInfo{DirName}) if $verbose;
     }
     # loop through all contained boxes
@@ -425,35 +603,44 @@
     for ($pos=$dirStart; ; $pos+=$boxLen) {
         my ($boxID, $buff, $valuePtr);
+        my $hdrLen = 8;     # the box header length
         if ($raf) {
-            $dataPos = $raf->Tell();
-            my $n = $raf->Read($buff,8);
-            unless ($n == 8) {
+            $dataPos = $raf->Tell() - $base;
+            my $n = $raf->Read($buff,$hdrLen);
+            unless ($n == $hdrLen) {
                 $n and $err = '', last;
                 if ($outfile) {
-                    CreateNewBoxes($exifTool, $outfile) or $err = 1;
+                    CreateNewBoxes($et, $outfile) or $err = 1;
                 }
                 last;
             }
             $dataPt = \$buff;
-            $dirLen = 8;
+            $dirLen = $dirEnd = $hdrLen;
             $pos = 0;
-        } elsif ($pos >= $dirEnd - 8) {
+        } elsif ($pos >= $dirEnd - $hdrLen) {
             $err = '' unless $pos == $dirEnd;
             last;
         }
-        $boxLen = unpack("x$pos N",$$dataPt);
+        $boxLen = unpack("x$pos N",$$dataPt);   # (length includes header and data)
         $boxID = substr($$dataPt, $pos+4, 4);
-        $pos += 8;
+        $pos += $hdrLen;                # move to end of box header
         if ($boxLen == 1) {
-            if (not $raf and $pos < $dirLen - 8) {
-                $err = 'JPEG 2000 format error';
-            } else {
-                $err = "Can't currently handle huge JPEG 2000 boxes";
+            # box header contains an additional 8-byte integer for length
+            $hdrLen += 8;
+            if ($raf) {
+                my $buf2;
+                if ($raf->Read($buf2,8) == 8) {
+                    $buff .= $buf2;
+                    $dirLen = $dirEnd = $hdrLen;
+                }
             }
-            last;
+            $pos > $dirEnd - 8 and $err = '', last;
+            my ($hi, $lo) = unpack("x$pos N2",$$dataPt);
+            $hi and $err = "Can't currently handle JPEG 2000 boxes > 4 GB", last;
+            $pos += 8;                  # move to end of extended-length box header
+            $boxLen = $lo - $hdrLen;    # length of remaining box data
         } elsif ($boxLen == 0) {
             if ($raf) {
                 if ($outfile) {
-                    CreateNewBoxes($exifTool, $outfile) or $err = 1;
+                    CreateNewBoxes($et, $outfile) or $err = 1;
                     # copy over the rest of the file
                     Write($outfile, $$dataPt) or $err = 1;
@@ -461,13 +648,16 @@
                         Write($outfile, $buff) or $err = 1;
                     }
+                } elsif ($verbose) {
+                    my $msg = sprintf("offset 0x%.4x to end of file", $dataPos + $base + $pos);
+                    $et->VPrint(0, "$$et{INDENT}- Tag '${boxID}' ($msg)\n");
                 }
                 last;   # (ignore the rest of the file when reading)
             }
-            $boxLen = $dirLen - $pos;
+            $boxLen = $dirEnd - $pos;   # data runs to end of file
         } else {
-            $boxLen -= 8;
+            $boxLen -= $hdrLen;         # length of remaining box data
         }
         $boxLen < 0 and $err = 'Invalid JPEG 2000 box length', last;
-        my $tagInfo = $exifTool->GetTagInfo($tagTablePtr, $boxID);
+        my $tagInfo = $et->GetTagInfo($tagTablePtr, $boxID);
         unless (defined $tagInfo or $verbose) {
             # no need to process this box
@@ -481,5 +671,5 @@
                 }
             } elsif ($outfile) {
-                Write($outfile, substr($$dataPt, $pos-8, $boxLen+8)) or $err = '', last;
+                Write($outfile, substr($$dataPt, $pos-$hdrLen, $boxLen+$hdrLen)) or $err = '', last;
             }
             next;
@@ -487,9 +677,9 @@
         if ($raf) {
             # read the box data
-            $dataPos = $raf->Tell();
+            $dataPos = $raf->Tell() - $base;
             $raf->Read($buff,$boxLen) == $boxLen or $err = '', last;
             $valuePtr = 0;
             $dataLen = $boxLen;
-        } elsif ($boxLen + $pos > $dirStart + $dirLen) {
+        } elsif ($pos + $boxLen > $dirEnd) {
             $err = '';
             last;
@@ -500,18 +690,37 @@
             # GetTagInfo() required the value for a Condition
             my $tmpVal = substr($$dataPt, $valuePtr, $boxLen < 128 ? $boxLen : 128);
-            $tagInfo = $exifTool->GetTagInfo($tagTablePtr, $boxID, \$tmpVal);
-        }
-        # delete all UUID boxes if deleting all information
-        if ($outfile and $boxID eq 'uuid' and $exifTool->{DEL_GROUP}->{'*'}) {
-            $exifTool->VPrint(0, "  Deleting $$tagInfo{Name}\n");
-            ++$exifTool->{CHANGED};
-            next;
+            $tagInfo = $et->GetTagInfo($tagTablePtr, $boxID, \$tmpVal);
+        }
+        # delete all UUID boxes and any writable box if deleting all information
+        if ($outfile and $tagInfo) {
+            if ($boxID eq 'uuid' and $$et{DEL_GROUP}{'*'}) {
+                $et->VPrint(0, "  Deleting $$tagInfo{Name}\n");
+                ++$$et{CHANGED};
+                next;
+            } elsif ($$tagInfo{Writable}) {
+                my $isOverwriting;
+                if ($$et{DEL_GROUP}{Jpeg2000}) {
+                    $isOverwriting = 1;
+                } else {
+                    my $nvHash = $et->GetNewValueHash($tagInfo);
+                    $isOverwriting = $et->IsOverwriting($nvHash);
+                }
+                if ($isOverwriting) {
+                    my $val = substr($$dataPt, $valuePtr, $boxLen);
+                    $et->VerboseValue("- Jpeg2000:$$tagInfo{Name}", $val);
+                    ++$$et{CHANGED};
+                    next;
+                } elsif (not $$tagInfo{List}) {
+                    delete $$et{AddJp2Tags}{$boxID};
+                }
+            }
         }
         if ($verbose) {
-            $exifTool->VerboseInfo($boxID, $tagInfo,
+            $et->VerboseInfo($boxID, $tagInfo,
                 Table  => $tagTablePtr,
                 DataPt => $dataPt,
                 Size   => $boxLen,
                 Start  => $valuePtr,
+                Addr   => $valuePtr + $dataPos + $base,
             );
             next unless $tagInfo;
@@ -528,5 +737,5 @@
                 Parent => 'JP2',
                 DataPt => $dataPt,
-                DataPos => $dataPos,
+                DataPos => -$subdirStart, # (relative to Base)
                 DataLen => $dataLen,
                 DirStart => $subdirStart,
@@ -534,15 +743,20 @@
                 DirName => $$subdir{DirName} || $$tagInfo{Name},
                 OutFile => $outfile,
-                Base => $dataPos + $subdirStart,
+                Base => $base + $dataPos + $subdirStart,
             );
+            my $uuid = $uuid{$$tagInfo{Name}};
+            # remove "UUID-" prefix to allow appropriate directories to be written as a block
+            $subdirInfo{DirName} =~ s/^UUID-//;
             my $subTable = GetTagTable($$subdir{TagTable}) || $tagTablePtr;
             if ($outfile) {
                 # remove this directory from our create list
-                delete $exifTool->{AddJp2Dirs}->{$$tagInfo{Name}};
+                delete $$et{AddJp2Dirs}{$$tagInfo{Name}};
                 my $newdir;
                 # only edit writable UUID boxes
-                if ($uuid{$$tagInfo{Name}}) {
-                    $newdir = $exifTool->WriteDirectory(\%subdirInfo, $subTable, $$subdir{WriteProc});
+                if ($uuid) {
+                    $newdir = $et->WriteDirectory(\%subdirInfo, $subTable, $$subdir{WriteProc});
                     next if defined $newdir and not length $newdir; # next if deleting the box
+                } elsif (defined $uuid) {
+                    $et->Warn("Not editing $$tagInfo{Name} box", 1);
                 }
                 # use old box data if not changed
@@ -552,16 +766,25 @@
                 $boxhdr .= substr($$dataPt, $valuePtr, $prefixLen) if $prefixLen;
                 Write($outfile, $boxhdr, $newdir) or $err = 1;
-            } elsif (not $exifTool->ProcessDirectory(\%subdirInfo, $subTable, $$subdir{ProcessProc})) {
-                if ($subTable eq $tagTablePtr) {
-                    $err = 'JPEG 2000 format error';
-                } else {
-                    $err = "Unrecognized $$tagInfo{Name} box";
+            } else {
+                # extract as a block if specified
+                $subdirInfo{BlockInfo} = $tagInfo if $$tagInfo{BlockExtract};
+                $et->Warn("Reading non-standard $$tagInfo{Name} box") if defined $uuid and $uuid eq '0';
+                unless ($et->ProcessDirectory(\%subdirInfo, $subTable, $$subdir{ProcessProc})) {
+                    if ($subTable eq $tagTablePtr) {
+                        $err = 'JPEG 2000 format error';
+                        last;
+                    }
+                    $et->Warn("Unrecognized $$tagInfo{Name} box");
                 }
-                last;
             }
         } elsif ($$tagInfo{Format} and not $outfile) {
             # only save tag values if Format was specified
-            my $val = ReadValue($dataPt, $valuePtr, $$tagInfo{Format}, undef, $boxLen);
-            $exifTool->FoundTag($tagInfo, $val) if defined $val;
+            my $rational;
+            my $val = ReadValue($dataPt, $valuePtr, $$tagInfo{Format}, undef, $boxLen, \$rational);
+            if (defined $val) {
+                my $key = $et->FoundTag($tagInfo, $val);
+                # save Rational value
+                $$et{RATIONAL}{$key} = $rational if defined $rational and defined $key;
+            }
         } elsif ($outfile) {
             my $boxhdr = pack('N', $boxLen + 8) . $boxID;
@@ -572,8 +795,8 @@
         $err or $err = 'Truncated JPEG 2000 box';
         if ($outfile) {
-            $exifTool->Error($err) unless $err eq '1';
+            $et->Error($err) unless $err eq '1';
             return $raf ? -1 : undef;
         }
-        $exifTool->Warn($err);
+        $et->Warn($err);
     }
     return $outBuff if $outfile and not $raf;
@@ -587,5 +810,6 @@
 sub ProcessJP2($$)
 {
-    my ($exifTool, $dirInfo) = @_;
+    local $_;
+    my ($et, $dirInfo) = @_;
     my $raf = $$dirInfo{RAF};
     my $outfile = $$dirInfo{OutFile};
@@ -594,13 +818,27 @@
     # check to be sure this is a valid JPG2000 file
     return 0 unless $raf->Read($hdr,12) == 12;
-    return 0 unless $hdr eq "\x00\x00\x00\x0cjP  \x0d\x0a\x87\x0a" or     # (ref 1)
-                    $hdr eq "\x00\x00\x00\x0cjP\x1a\x1a\x0d\x0a\x87\x0a"; # (ref 2)
-
+    unless ($hdr eq "\x00\x00\x00\x0cjP  \x0d\x0a\x87\x0a" or     # (ref 1)
+            $hdr eq "\x00\x00\x00\x0cjP\x1a\x1a\x0d\x0a\x87\x0a") # (ref 2)
+    {
+        return 0 unless $hdr =~ /^\xff\x4f\xff\x51\0/;  # check for JP2 codestream format
+        if ($outfile) {
+            $et->Error('Writing of J2C files is not yet supported');
+            return 0
+        }
+        # add J2C markers if not done already
+        unless ($Image::ExifTool::jpegMarker{0x4f}) {
+            $Image::ExifTool::jpegMarker{$_} = $j2cMarker{$_} foreach keys %j2cMarker;
+        }
+        $et->SetFileType('J2C');
+        $raf->Seek(0,0);
+        return $et->ProcessJPEG($dirInfo);    # decode with JPEG processor
+    }
     if ($outfile) {
         Write($outfile, $hdr) or return -1;
-        $exifTool->InitWriteDirs(\%jp2Map);
+        $et->InitWriteDirs(\%jp2Map);
         # save list of directories to create
-        my %addDirs = %{$$exifTool{ADD_DIRS}};
-        $$exifTool{AddJp2Dirs} = \%addDirs;
+        my %addDirs = %{$$et{ADD_DIRS}};
+        $$et{AddJp2Dirs} = \%addDirs;
+        $$et{AddJp2Tags} = $et->GetNewTagInfoHash(\%Image::ExifTool::Jpeg2000::Main);
     } else {
         my ($buff, $fileType);
@@ -611,5 +849,5 @@
         }
         $raf->Seek(-length($buff), 1) if defined $buff;
-        $exifTool->SetFileType($fileType);
+        $et->SetFileType($fileType);
     }
     SetByteOrder('MM'); # JPEG 2000 files are big-endian
@@ -620,5 +858,5 @@
     );
     my $tagTablePtr = GetTagTable('Image::ExifTool::Jpeg2000::Main');
-    return $exifTool->ProcessDirectory(\%dirInfo, $tagTablePtr);
+    return $et->ProcessDirectory(\%dirInfo, $tagTablePtr);
 }
 
@@ -642,5 +880,5 @@
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
